#include "window.hpp"

Window::Window() : QObject()
{
	mainWidget = new QWidget();

	subWidget0 = new QWidget();
	subWidget1 = new QWidget();
	subWidget2 = new QWidget();
	subWidget3 = new QWidget();

	mainLayout = new QVBoxLayout();

	subLayout0 = new QHBoxLayout();
	subLayout1 = new QHBoxLayout();
	subLayout2 = new QHBoxLayout();
	subLayout3 = new QHBoxLayout();

	mainLayout->addWidget(subWidget0);
	mainLayout->addWidget(subWidget1);
	mainLayout->addWidget(subWidget2);
	mainLayout->addWidget(subWidget3);

	mainWidget->setLayout(mainLayout);

	subWidget0->setLayout(subLayout0);
	subWidget1->setLayout(subLayout1);
	subWidget2->setLayout(subLayout2);
	subWidget3->setLayout(subLayout3);

	numberOfElements1 = new QLabel("Number of elements:");
	numberOfElements2 = new QLabel("0");

	subLayout0->addWidget(numberOfElements1);
	subLayout0->addWidget(numberOfElements2);

	topOfStack1 = new QLabel("Top of stack:");
	topOfStack2 = new QLabel("(empty)");

	subLayout1->addWidget(topOfStack1);
	subLayout1->addWidget(topOfStack2);

	edit = new QLineEdit();

	subLayout2->addWidget(edit);

	push = new QPushButton("PUSH");
	add = new QPushButton("ADD");
	mul = new QPushButton("MUL");
	addInv = new QPushButton("ADD INV");
	mulInv = new QPushButton("MUL INV");

	subLayout3->addWidget(push);
	subLayout3->addWidget(add);
	subLayout3->addWidget(mul);
	subLayout3->addWidget(addInv);
	subLayout3->addWidget(mulInv);

	mainWidget->setWindowTitle("Stack based calculator");
	mainWidget->show();
}

void Window::setNumberOfElements(int i)
{
	numberOfElements2->setText(QString::number(i));
}

void Window::setTopOfStack(std::string s)
{
	topOfStack2->setText(QString::fromStdString(s));
}
